from setuphelpers import *
import wmi
import win32serviceutil
import win32service

uninstallkey = []


def install():
    netcfg = wmi.WMI().win32_NetworkAdapterConfiguration
    for connection in netcfg.query(IPEnabled=True):
        if connection.TcpipNetbiosOptions != 2:
            print(u"Disabling Netbios on %s" % connection.Description)
            connection.SetTcpipNetbios(2)

    if service_is_running("lmhosts"):
        service_stop("lmhosts")
        win32serviceutil.ChangeServiceConfig(None, "lmhosts", win32service.SERVICE_DISABLED)


def uninstall():
    netcfg = wmi.WMI().win32_NetworkAdapterConfiguration
    for connection in netcfg.query(IPEnabled=True):
        if connection.TcpipNetbiosOptions == 2:
            print(u"Enabling Netbios on %s" % connection.Description)
            connection.SetTcpipNetbios(0)
    win32serviceutil.ChangeServiceConfig(None, "lmhosts", win32service.SERVICE_AUTO_START)
    # if not service_is_running("lmhosts"):
    #     service_start("lmhosts")


def audit():
    netcfg = wmi.WMI().win32_NetworkAdapterConfiguration
    has_netbios = []
    for connection in netcfg.query(IPEnabled=True):
        if connection.TcpipNetbiosOptions != 2:
            has_netbios.append(connection.Description)
    if has_netbios:
        print(u"ERROR: Netbios is not disabled on interfaces :\n%s" % u"\n".join(has_netbios))
        return "ERROR"
    elif service_is_running("lmhosts"):
        print(u"ERROR: LMHosts netbios helper is running")
        return "ERROR"
    else:
        return "OK"
